// license-header java merge-point
/**
 * This is only generated once! It will never be overwritten.
 * You can (and have to!) safely modify it by hand.
 */
package fugeOM.service;

import fugeOM.Common.DescribableDao;
import fugeOM.Common.IdentifiableDao;
import org.dom4j.Element;

import java.lang.reflect.Method;


/**
 * @see fugeOM.service.RealizableEntityService
 */
public class RealizableEntityServiceImpl
        extends fugeOM.service.RealizableEntityServiceBase {

    /**
     * @see fugeOM.service.RealizableEntityService#getDescribableOb(java.lang.Long)
     */
    protected java.lang.Object handleGetDescribableOb( java.lang.Long id )
            throws java.lang.Exception {
        return ( Object ) getDescribableDao().load( DescribableDao.TRANSFORM_NONE, id );
    }

    /**
     * @see fugeOM.service.RealizableEntityService#getIdentifiableOb(java.lang.Long)
     */
    protected java.lang.Object handleGetIdentifiableOb( java.lang.Long id )
            throws java.lang.Exception {
        return ( Object ) getIdentifiableDao().load( IdentifiableDao.TRANSFORM_NONE, id );
    }

    /**
     * #@see fugeOM.service.RealizableEntityService#createDescribable(java.lang.String, java.lang.String, java.lang.String)
     */
    protected java.lang.Object handleCreateIdentifiableOb( java.lang.String entityType, java.lang.String fugeIdentifier, java.lang.String fugeName, java.lang.String fullClassName )
            throws java.lang.Exception {
        // @todo implement protected java.lang.Object handleCreateDescribable(java.lang.String entityType, java.lang.String fugeIdentifier, java.lang.String fugeName)

        Object createdDescribable = null;


        try {


            Method newInstanceMethod = Class.forName( fullClassName + "$Factory" ).getMethod( "newInstance", null );
            createdDescribable = ( Object ) newInstanceMethod.invoke( null, null );

            /*
              Class superclaz = this.getClass().getSuperclass();

              Method[] meths = superclaz.getMethods();

              for(int i =0; i<meths.length;i++){
                   System.out.println("Method: " + meths[i].getName());
              }
              */
            //Method test = Class.forName("fugeOM.service.RealizableEntityServiceBase").getMethod("getGenericProtocolDao",null);

            //Method daoMethod = Class.forName("fugeOM.service.RealizableEntityServiceBase").getMethod(getDao,null);

            //Class entityClass = Class.forName(fullClassName);


            Class[] args2 = {Class.forName( "java.lang.String" )};
            Object[] args3 = {( Object ) fugeIdentifier};

            //Set the identifier...
            if ( fugeIdentifier != null ) {
                Method setIdentifierMethod = Class.forName( fullClassName ).getMethod( "setIdentifier", args2 );
                setIdentifierMethod.invoke( createdDescribable, args3 );    //should put some error checking in here... only try to do this if these are identifiable... I guess this will cause an exception if it is not...
            }

            if ( fugeName != null ) {
                Object[] args4 = {( Object ) fugeName};
                Method setNameMethod = Class.forName( fullClassName ).getMethod( "setName", args2 );
                setNameMethod.invoke( createdDescribable, args4 );
            }


        }
        catch ( Exception e ) {
            e.printStackTrace();
        }


        return createdDescribable;
    }

    /**
     * #@see fugeOM.service.RealizableEntityService#createDescribable(java.lang.String, java.lang.String, java.lang.String)
     */
    protected java.lang.Object handleCreateDescribableOb( java.lang.String entityType, java.lang.String fullClassName )
            throws java.lang.Exception {
        // @todo implement protected java.lang.Object handleCreateDescribable(java.lang.String entityType, java.lang.String fugeIdentifier, java.lang.String fugeName)

        Object createdDescribable = null;

        try {


            Method newInstanceMethod = Class.forName( fullClassName + "$Factory" ).getMethod( "newInstance", null );
            createdDescribable = ( Object ) newInstanceMethod.invoke( null, null );

        }
        catch ( Exception e ) {
            e.printStackTrace();
        }


        return createdDescribable;
    }


    protected java.lang.Long handleCreateObInDB( java.lang.String entityType, java.lang.String fullClassName, java.lang.Object describable )
            throws java.lang.Exception {
        Long dbID = null;

        Object[] args = {describable};
        Class[] args1 = {Class.forName( fullClassName )};

        String getDao = "get" + entityType + "Dao";

        Method daoMethod = this.getClass().getSuperclass().getDeclaredMethod( getDao, null );
        Object daoObj = daoMethod.invoke( this, null );
        Method createMethod = Class.forName( fullClassName + "Dao" ).getMethod( "create", args1 );
        // Create the object in the database...
        createMethod.invoke( daoObj, args );

        Method getIDMethod = Class.forName( fullClassName ).getMethod( "getId", null );
        dbID = ( Long ) getIDMethod.invoke( describable, null );

        return dbID;
    }

    protected void handleUpdateObInDB( java.lang.String entityType, String fullClassName, Object describable )
            throws java.lang.Exception {
        try {

            Object[] args = {describable};
            Class[] args1 = {Class.forName( fullClassName )};

            String getDao = "get" + entityType + "Dao";

            Method daoMethod = this.getClass().getSuperclass().getDeclaredMethod( getDao, null );
            Object daoObj = daoMethod.invoke( this, null );
            Method updateMethod = Class.forName( fullClassName + "Dao" ).getMethod( "update", args1 );
            //Create the Describable object in the database...
            updateMethod.invoke( daoObj, args );

        }
        catch ( Exception e ) {
            e.printStackTrace();
        }
    }

    /**
     * @see fugeOM.service.RealizableEntityService#findIdentifiable(java.lang.String)
     */
    protected java.lang.Object handleFindIdentifiable( java.lang.String fugeIdentifier )
            throws java.lang.Exception {
        Object obj = null;
        System.out.println( "Searching for fugeIdentifier = " + fugeIdentifier );
        obj = getIdentifiableDao().getObByFugeIdentifier( fugeIdentifier );

        if ( obj == null ) {
            throw new java.lang.Exception( "No such fugeIdentifier found: " + fugeIdentifier );
        }

        return obj;
    }
}